Attribute VB_Name = "modCOMMDLG"
Option Compare Text
Option Explicit

Public Type tagOPENFILENAME
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        nFilterIndex As Long
        lpstrFile As String
        nMaxFile As Long
        lpstrFileTitle As String
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
        flags As Long
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As String
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type

Public Const OFN_ALLOWMULTISELECT = &H200
Public Const OFN_CREATEPROMPT = &H2000
Public Const OFN_ENABLEHOOK = &H20
Public Const OFN_ENABLETEMPLATE = &H40
Public Const OFN_ENABLETEMPLATEHANDLE = &H80
Public Const OFN_EXPLORER = &H80000
Public Const OFN_EXTENSIONDIFFERENT = &H400
Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_LONGNAMES = &H200000
Public Const OFN_NOCHANGEDIR = &H8
Public Const OFN_NODEREFERENCELINKS = &H100000
Public Const OFN_NOLONGNAMES = &H40000
Public Const OFN_NONETWORKBUTTON = &H20000
Public Const OFN_NOREADONLYRETURN = &H8000
Public Const OFN_NOTESTFILECREATE = &H10000
Public Const OFN_NOVALIDATE = &H100
Public Const OFN_OVERWRITEPROMPT = &H2
Public Const OFN_PATHMUSTEXIST = &H800
Public Const OFN_READONLY = &H1
Public Const OFN_SHAREAWARE = &H4000
Public Const OFN_SHAREFALLTHROUGH = 2
Public Const OFN_SHARENOWARN = 1
Public Const OFN_SHAREWARN = 0
Public Const OFN_SHOWHELP = &H10

Global Const OFN_OPENEXISTING = OFN_PATHMUSTEXIST Or OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY
Global Const OFN_SAVENEW = OFN_PATHMUSTEXIST Or OFN_OVERWRITEPROMPT Or OFN_HIDEREADONLY
Global Const OFN_SAVENEWPATH = OFN_OVERWRITEPROMPT Or OFN_HIDEREADONLY

Declare Function GetActiveWindow Lib "user32" () As Long
Public Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As tagOPENFILENAME) As Long
Public Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As tagOPENFILENAME) As Long
Public Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Public Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long


Public Const CSIDL_FLAG_CREATE = &H8000
Public Const CSIDL_FLAG_DONT_VERIFY = &H4000
Public Const CSIDL_FLAG_MASK = &HFF00
Public Const SHGFP_TYPE_CURRENT = &H0
Public Const SHGFP_TYPE_DEFAULT = &H1

Public Const MAX_PATH = 260
Public Const S_OK = 0

'Converts an item identifier list to a file system path.
Public Declare Function SHGetPathFromIDList Lib "shell32.dll" _
   Alias "SHGetPathFromIDListA" _
  (ByVal pidl As Long, _
   ByVal pszPath As String) As Long

Public Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" _
   (ByVal hwndOwner As Long, _
    ByVal nFolder As Long, _
    pidl As Long) As Long

Public Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long)




Dim OPENFILENAME As tagOPENFILENAME


Function CommFileDialog( _
 Optional strInitDir As String, _
 Optional strFilter As String = _
  "All files (*.*)" & vbNullChar & "*.*" & _
  vbNullChar & vbNullChar, _
 Optional intFilterIndex As Integer = 1, _
 Optional strDefaultExt As String = "", _
 Optional strFilename As String = "", _
 Optional strDialogTitle As String = "Open File", _
 Optional hWnd As Long = -1, _
 Optional fOpenFile As Boolean = True, _
 Optional ByRef lngFlags As Long = _
  OFN_OPENEXISTING Or OFN_SAVENEWPATH) As Variant
    Dim ofn As tagOPENFILENAME
    Dim strFileTitle As String
    Dim fResult As Boolean


    If strInitDir = "" Then
        strInitDir = CurDir
    End If
    If hWnd = -1 Then
        hWnd = GetActiveWindow()
    End If


    strFilename = strFilename & String(255 - Len(strFilename), 0)
    strFileTitle = String(255, 0)


    With ofn
        .lStructSize = Len(ofn)
        .hwndOwner = hWnd
        .lpstrFilter = strFilter
        .nFilterIndex = intFilterIndex
        .lpstrFile = strFilename
        .nMaxFile = Len(strFilename)
        .lpstrFileTitle = strFileTitle
        .nMaxFileTitle = Len(strFileTitle)
        .lpstrTitle = strDialogTitle
        .flags = lngFlags
        .lpstrDefExt = strDefaultExt
        .lpstrInitialDir = strInitDir
        .hInstance = 0
        .lpstrCustomFilter = String(255, 0)
        .nMaxCustFilter = 255
        .lpfnHook = 0
    End With


    If fOpenFile Then
        fResult = GetOpenFileName(ofn)
    Else
        fResult = GetSaveFileName(ofn)
    End If

    If fResult Then

        lngFlags = ofn.flags
        

        If (ofn.flags And OFN_ALLOWMULTISELECT) = 0 Then
            CommFileDialog = Trim$(Left$(ofn.lpstrFile, Len(ofn.lpstrFile) - 1))
        Else
            CommFileDialog = ofn.lpstrFile
        End If
    Else
        CommFileDialog = Null
    End If
End Function



Public Function GetSpecialFolderLocation(hWnd As Long) As String

   Dim sPath As String
   Dim pidl As Long
   
  'fill the idl structure with the specified folder item
   If SHGetSpecialFolderLocation(hWnd, &H5, pidl) = S_OK Then
     
     'if the pidl is returned, initialize
     'and get the path from the id list
      sPath = Space$(MAX_PATH)
      
      If SHGetPathFromIDList(ByVal pidl, ByVal sPath) Then

        'return the path
         GetSpecialFolderLocation = Left(sPath, InStr(sPath, Chr$(0)) - 1)
         
      End If
    
     'free the pidl
      Call CoTaskMemFree(pidl)

    End If
   
End Function
